'use strict';

var isBuiltinModule = require('is-builtin-module');
var options = require('@rollup-extras/utils/options');
var logger = require('@rollup-extras/utils/logger');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var isBuiltinModule__default = /*#__PURE__*/_interopDefaultLegacy(isBuiltinModule);
var logger__default = /*#__PURE__*/_interopDefaultLegacy(logger);

const factories = { logger: logger__default["default"] };
function index (options$1 = {}) {
    const { pluginName, external, logger, verbose } = options.getOptionsObject(options$1, {
        pluginName: '@rollup-extras/plugin-externals',
        verbose: false
    }, factories);
    const logLevel = verbose ? 1 /* info */ : 0 /* verbose */;
    return {
        name: pluginName,
        resolveId(id) {
            let isExternal = id.includes('node_modules') || isBuiltinModule__default["default"](id);
            if (external) {
                isExternal = external(id, isExternal);
            }
            logger(`'${id}' is ${isExternal ? '' : 'not '}external`, logLevel);
            return isExternal ? false : null;
        }
    };
}

module.exports = index;
